#include "variables.h"
#include <unistd.h>
typedef word24 				nameSp[SpDIM];
typedef word24				nameTp[TpDIM];


nameSp SpNAME;
nameTp TpNAME;


void NameSpecies(nameSp SpNAME, nameTp TpNAME)
{
 int k;
strcpy(SpNAME[h2oSP],"Water");
strcpy(SpNAME[nh42so4SP],"AmmoniumSulfate");
strcpy(SpNAME[nh4hso4SP],"AmmoniumBisulfate");
strcpy(SpNAME[blkCSP],"BlackCarbon");
strcpy(SpNAME[naclSP],"SodiumChloride");
strcpy(SpNAME[orgCSP],"OrganicCarbon"); 
strcpy(SpNAME[dmsSP],"DimethylSulfide");
strcpy(SpNAME[so2SP],"SulfurDioxide"); 
strcpy(SpNAME[h2so4SP],"SulfuricAcid");
strcpy(TpNAME[saltTP],"SeaSalt");
strcpy(TpNAME[sulfateTP],"nssSulfate");
strcpy(TpNAME[plumeTP],"Plume");
strcpy(TpNAME[contlTP],"Continental");
/*,"Plume","Unknown"};*/
return;
}

void ReportMet(int first,double t,double ht,double temp,double pres,double rhum, double lwc, double Parcelt, double Updraft)
{
 word24	FileName;
 FILE *FilePtr;
strcpy(FileName,MetOUT);
strcat(FileName,OUTsuffix);
if (first==0) {
  FilePtr=fopen(FileName,"w");
  fprintf(FilePtr,"Time, Altitude, Temperature, Pressure, ");
  fprintf(FilePtr,"RelativeHumidity,LiquidWaterContent, ParcelTemperature, Updraft\n");
  fprintf(FilePtr,"(sec),(m),(deg.K),(mbar),(percent),(g*m-3),(deg.K),(m*s-1)\n");
  fprintf(FilePtr,"\n\n");
  fclose(FilePtr);}
FilePtr=fopen(FileName,"a");
fprintf(FilePtr,"%.1f, %.1f, %.2f, %.2f, %.4f, %.6f, %.2f, %.2f\n",
 t,ht,temp,pres,rhum*100.,lwc*CCperM3,Parcelt, Updraft);
fclose(FilePtr);
return;
}


void ReportCv(int first,double t,arySp Cv)
{
 nameSp SpNAME;	 	nameTp TpNAME;
 int j;  
 word24	FileName;
 FILE *FilePtr;
strcpy(FileName,CvOUT);
strcat(FileName,OUTsuffix);
if (first==0) {
  NameSpecies(SpNAME,TpNAME);
  FilePtr=fopen(FileName,"w");
  fprintf(FilePtr,"Gas Concentrations in g*cm-3\n");
  fprintf(FilePtr,"Time, ");
  for (j=0;j<SpDIM;j++) {if ((j==h2oSP)|(j==dmsSP)|(j==so2SP)|(j==h2so4SP)){ 
    fprintf(FilePtr,"%s, ",SpNAME[j]);}}
  fprintf(FilePtr,"\n\n");
  fclose(FilePtr);}
FilePtr=fopen(FileName,"a");
fprintf(FilePtr,"%f, ",t);
for (j=0;j<SpDIM;j++) {if ((j==h2oSP)|(j==dmsSP)|(j==so2SP)|(j==h2so4SP)) { 
  fprintf(FilePtr,"%e, ",Cv[j]);}}
fprintf(FilePtr,"\n");
fclose(FilePtr);
return;
}

void ReportNp(int first,double t,aryDpTp Np)
{
 nameSp SpNAME;	 	nameTp TpNAME;
 int i,k;
 FILE *FilePtr;  
 word24 FileName,TpStr; 
 double dLogDp=1;
dLogDp=LOG(dryDp(DpMAX+0.5)/dryDp(DpMAX-0.5));
for (k=0;k<TpDIM;k++){
  strcpy(FileName,NpOUT);
  sprintf(TpStr,"%02d",k);
  strcat(FileName,TpStr);
  strcat(FileName,OUTsuffix);
  if (first==0) {
    NameSpecies(SpNAME,TpNAME);
    FilePtr=fopen(FileName,"w");
    fprintf(FilePtr,"Number Concentrations for Type %d (%s)\n",
     k,TpNAME[k]);
    fprintf(FilePtr," Concentrations (dN/dlog10Dp) in cm-3,"); 
    fprintf(FilePtr," Diameters (dry) in microns\n");
    fprintf(FilePtr,"Time, ");
    for (i=0;i<DpDIM;i++) {fprintf(FilePtr,"%e, ",dryDp(i));}
    fprintf(FilePtr,"\n\n");
    fclose(FilePtr);}
  FilePtr=fopen(FileName,"a");
  fprintf(FilePtr,"%f, ",t);
  for (i=0;i<DpDIM;i++) {fprintf(FilePtr,"%e, ",Np[i][k]/dLogDp);}
  fprintf(FilePtr,"\n");
  fclose(FilePtr);
}
return;
}

void ReportMp(int first,double t,aryDpSpTp Mp) {
 nameSp SpNAME;	 	nameTp TpNAME;
 int i,j,k;
 FILE *FilePtr;  
 word24 FileName,TpStr,SpStr; 
 double dLogDp=1;
dLogDp=LOG(dryDp(DpMAX+0.5)/dryDp(DpMAX-0.5));
for (k=0;k<TpDIM;k++){
  for (j=0;j<SpDIM;j++) {
    strcpy(FileName,MpOUT);
    sprintf(TpStr,"%02d",k);
    strcat(FileName,TpStr);
    sprintf(SpStr,"%02d",j);
    strcat(FileName,SpStr);
    strcat(FileName,OUTsuffix);
    if (first==0) {
      NameSpecies(SpNAME,TpNAME); 
      FilePtr=fopen(FileName,"w");
      fprintf(FilePtr,"Mass Concentrations for Type %d (%s) Species %d (%s)\n",
       k,TpNAME[k],j,SpNAME[j]);
      fprintf(FilePtr," Mass (dM/dlog10Dp) Concentrations in g*cm-3,");
      fprintf(FilePtr," Diameters (dry) in microns\n");
      fprintf(FilePtr,"Time, ");
      for (i=0;i<DpDIM;i++) {fprintf(FilePtr,"%e, ",dryDp(i));}
      fprintf(FilePtr,"\n\n");
      fclose(FilePtr);}
    FilePtr=fopen(FileName,"a");
    fprintf(FilePtr,"%f, ",t);
    for (i=0;i<DpDIM;i++) {fprintf(FilePtr,"%e, ",Mp[i][j][k]/dLogDp);}
    fprintf(FilePtr,"\n");
    fclose(FilePtr);
} } 
return;
}


void ReportDp(int first,double t,aryDpSpTp Mp,aryDpTp Np) {
 nameSp SpNAME;	 	nameTp TpNAME;
 int i,j,k;
 FILE *FilePtr;  
 word24 FileName,TpStr,SpStr; 
 double dLogDp=1;
dLogDp=LOG(dryDp(DpMAX+0.5)/dryDp(DpMAX-0.5));
for (k=0;k<TpDIM;k++){
    strcpy(FileName,DpOUT);
    sprintf(TpStr,"%02d",k);
    strcat(FileName,TpStr);
    strcat(FileName,OUTsuffix);
    if (first==0) {
      NameSpecies(SpNAME,TpNAME); 
      FilePtr=fopen(FileName,"w");
      fprintf(FilePtr,"Ambient sectional diameters for Type %d (%s) \n",
       k,TpNAME[k]);
      fprintf(FilePtr," Ambient Diameters in microns,");
      fprintf(FilePtr," Diameters (dry) in microns\n");
      fprintf(FilePtr,"Time, ");
      for (i=0;i<DpDIM;i++) {fprintf(FilePtr,"%e, ",dryDp(i));}
      fprintf(FilePtr,"\n\n");
      fclose(FilePtr);}
    FilePtr=fopen(FileName,"a");
    fprintf(FilePtr,"%f, ",t);
    for (i=0;i<DpDIM;i++) {fprintf(FilePtr,"%e, ", 
     wetDp(i,k,Mp[i][h2oSP][k],Mp,Np[i][k]));}
    fprintf(FilePtr,"\n");
    fclose(FilePtr);
} 
return;
}

void ReportAct(int Dp, double wetD, double Act, double mzSum, double mzSum2, double OsmCoef, double mzOrg, double h2oM, double alt)
{
 word24 FileName;
 FILE *FilePtr;
 double diam;
strcpy(FileName,mzsumtest);
strcat(FileName,OUTsuffix);
if( access(FileName, F_OK) == -1){
  FilePtr=fopen(FileName,"w");
  fprintf(FilePtr,"Diam, WetDp, Activity, mzSum, mzSum2, OsmCoef, mzOrg, h2oMp, alt");
  fprintf(FilePtr,"\n\n");
  fclose(FilePtr);}
FilePtr=fopen(FileName,"a");
diam = dryDp(Dp);
fprintf(FilePtr,"%.4f, %.4f, %.6f, %.6f, %.6f, %.6f, %.6f, %.12f, %.2f\n",diam, wetD, Act, mzSum, mzSum2, OsmCoef, mzOrg, h2oM, alt);
fclose(FilePtr);
return;
}
